;
;	>> PigXLs - Stage 5 <<
;
;	A 128 bytes intro for the Atari 800 XL (c) 2010-09-15 by JAC!
;	Stage 5: Lores mode with stack/PLA adressing and scaled coordinates, color based on coordinates, $d20x rhythm sound and players
;
;	Created using WUDSN IDE. Visit http://www.wudsn.com to increase my hit counter.

	.opt ill

;	IOCB commands
open	= $03
close	= $0c
plot	= $09
draw	= $11
fill	= $12

iocom	= $342	;Command
ioadr	= $344	;Address
icaux1	= $034A	;Auxilary 1
icaux2	= $034B	;Auxilary 2
ciov	= $e456	;CIO vector

rowcrs	= $54	;Row of cursor, 1 byte
colcrs	= $55	;Column of cursor, 2 bytes

color	= $2fb	;Color for graphics operations

*	= $154	;Start at stack position "S"=$53

;	These are the x,y corrdinates for the lines.
;	Bit 0 in the x coordinate is also the line color.
;	The first line is black because is implicitly starts at 0,0.
;	The last relevant coordinate must be the same as the first, except for the color.
;	The coordinates are chosen in a way they represent valid code.
;	This allows the demo to start without having a RUNADR segment. 
;	.byte   x,   y,   x,   y,   x,   y,   x,   y,   x,   y,   x,   y,   x,   y
pigxy	.byte 12,24,

start
	ldx #'S		;Instead of string definition "S:",$9B, causes also invisible line.
 	stx $00		;Operand $00 will terminate drawloop
 	txs		;X=$53 => PLA will start at $154
	ldx #$10	;Channel 1
	lda #open	;Set open command
	sta iocom,x
	
	asl		;Graphics 2*3 = 6, 2 colors
	sta icaux2,x	;icaus1,x is already 0
drawloop
 	jsr ciov	;Leaves a and x unchanged, returns y=1
	lda #draw	;Set draw command
	sta iocom,x
 	pla		;Pull x corrdinate
	sta colcrs
	lda #1
 	sta color	;Bit 0 of the xpos is the color
 	pla		;Pully y coordinate
 	sta rowcrs
	bne drawloop	;Will end when PLA has reached "stx $00".

	dex		;X will become $0f

effloop ldy #15
	cpy $d40b
	bne effloop
effloop1
	lda $d40b
	tay
	and #3
	sec
	adc $400,y
	sta $400,y
	sta $d40a
	sta $d000
	lda $d40b
	adc 20
	lsr
	bit bit4
	beq *+4
	eor #$1f
	sta $d012
;	lsr
;	lsr
;	lsr
;	ora #$fc
;	sta fish1
	ldx #5
	sta $d40a
dofish
	lda fish,x
	sta $d40a
	sta $d00d
	sta $d40a
	dex
	bpl dofish

	tya
	bit bitx
	beq *+4
	adc #$40
	sta $d01a
	iny
	cpy #10
	bne effloop1
	jmp effloop

bitx	.byte $08
fish	.byte 0,0,0
	.byte ~10001110
	.byte ~11011111
fish1	.byte ~11111100
	.byte ~11011011
	.byte ~10001110

bit4	.byte $10
*	= $2e0
	.word start